/*
 * 2015/06/12 turtle3.c
 */

#include <stdio.h>

/*
 *	亀プログラムには、s_turtle.h が必要
 */

#include "s_turtle.h"

/*
 * 再帰曲線
 */

void move ( int n ) {
  if ( n <= 0 ) {
  } else {
    s_turtle_move();
    move ( n - 1 );
  }
}

void turn ( int n ) {
  if ( n <= 0 ) {
  } else {
    s_turtle_turn();
    turn ( n - 1 );
  }
}

void jump ( int n ) {
  if ( n <= 0 ) {
  } else {
    s_turtle_jump();
    jump ( n - 1 );
  }
}

/*
 * コッホ曲線
 * 
 *  + + + + + + + + + + + + + + + + +
 * 
 * 
 *                  +
 *                +   +
 *              +       + 
 *            +           +
 *  + + + + +               + + + + +
 *
 *
 *
 *                  +
 *            +   +   +   +
 *                        
 *      +     +           +     +
 *  + +   + +               + +   + +
 */

void koch ( int n ) {
  if ( n <= 0 ) {
    move ( 2 );
  } else {
    koch ( n - 1 );
    turn ( 1 );
    koch ( n - 1 );
    turn ( 6 );
    koch ( n - 1 );
    turn ( 1 );
    koch ( n - 1 );
  }
}

int main ( void ) {

  turn ( 2 );
  jump ( 90 );
  turn ( 4 );

  koch ( 1 );

  jump ( 10 );

  koch ( 2 );

  jump ( 10 );

  koch ( 3 );

  putchar ( '>' );
  putchar ( getchar() );

  s_turtle_stop();

  return 0;
}

